# General concepts for the Poulpe performance tool suite

## General philosophy

(and far too many other stuff as we have a single doc file for now)

## Building blocks

### Data Environment

Data environments are directories that contain the data to be used in a
benchmark.

Inside each data-env is a `data-env.poulpe` file, which specifies the data
source, metadata, arguments and transformations needed to setup for a benchmark.

Data environments can define "data variables" whose values will be used by the
benchmarks. A given benchmark could only make sense if the data it's using
has certain characteristics. For example, testing the performance of listing
the last 10000 revisions of a repository requires... at least 10000 revisions.

### Binary Environment

A directory containing a `bin-env.poulpe` file that describes the binary
environment and a `bin-env.shell` to provide us with a shell within that binary
environment.

### Benchmark

A `xxx.pdb` file that describes how to run a specific benchmark and its
variants.

The variables from the data-envs can be used to configure the benchmark.

Benchmarks can have variants, variants exist in independent **dimensions**.
Each dimension has a set of values, each value can modify the benchmark and each
dimension must have a default value.

## Running benchmarks

### Individual Runs

Each benchmark can be run individually. This gives us more flexibility to run
comparative runs, schedule runs and debug faulty ones.

This is done through the `run-util` executable

### Results

Each result can be manipulated and compared individually.

They currently exist as `xxx.pbr` files. Having the option to group them
(for example) in a database will be necessary for scaling.

### Scheduling

Scheduling is currently minimal and will need further improvements in the
future. It is tied to using a Poulpe den, see [poulpe-den.md](poulpe-den.md).

The scheduling installs new bin-envs and cleans up older ones.

### Using results

You can use `poulpe result-search` and `poulpe result-compare` to find and
compare results. Note that these commands and quite low-level and a higher-level
interface needs to be developed.
