class BinEnvSetupFailure(RuntimeError):
    pass


class BenchmarkFailure(RuntimeError):
    pass


class BenchmarkRunFailure(BenchmarkFailure):
    def __init__(
        self,
        command=None,
        cwd=None,
        return_code=None,
        stdout=None,
        stderr=None,
        message=None,
    ):
        self.command = command
        self.cwd = cwd
        self.return_code = return_code
        self.stdout = stdout
        self.stderr = stderr
        self.message = message


class MissingDataEnvInputVar(KeyError):
    pass


class MissingBinEnvInputVar(KeyError):
    pass


class InvalidBrick(RuntimeError):
    def __init__(self, message, brick_file) -> None:
        message = f"'{brick_file}': {message}"
        super().__init__(message)
        self.brick_file = brick_file
