use std::path::PathBuf;

use crate::utils::split_unescape;

#[derive(Clone)]
pub struct DataEnvironment {
    pub root: PathBuf,
    pub name: String,
    /// Corresponds to the data-env.poulpe contents
    pub metadata: toml::Value,
}

impl DataEnvironment {
    pub fn get_bench_input_var(&self, var: &str) -> Option<String> {
        let mut current = self.metadata.get("bench-input-vars")?;

        for var in split_unescape(var, '.', '\\') {
            current = current.get(var)?;
        }

        current.as_str().map(ToOwned::to_owned)
    }
}
