use std::{error::Error, path::Path};

use den::Den;

pub mod benchmark;
pub mod binary_environment;
pub mod data_environment;
pub mod den;
pub mod result;
pub mod runner;
pub mod scheduling;
pub mod suite;
pub mod utils;

#[cfg(not(target_arch = "wasm32"))]
pub fn gather_den(root: impl AsRef<Path>) -> Result<Den, Box<dyn Error>> {
    Den::new_from_disk(root.as_ref())
}

#[cfg(target_arch = "wasm32")]
pub fn gather_den(root: impl AsRef<Path>) -> Result<Den, Box<dyn Error>> {
    Err("Loading the den remotely is not available yet".into())
}
