use egui::{Context, Key, TextEdit, Ui, ViewportCommand};

use crate::{Dashboard, IS_WEB};

pub fn render_menu(dashboard: &mut Dashboard, ctx: &Context, ui: &mut Ui) {
    if IS_WEB {
        // TODO address of a dashboard server?
        return;
    }
    ui.menu_button("File", |ui| {
        if ui.button("Quit").clicked() {
            ctx.send_viewport_cmd(ViewportCommand::Close);
        }
    });

    ui.separator();

    if TextEdit::singleline(&mut dashboard.den_path_input)
        .desired_width(500.0)
        .show(ui)
        .response
        .lost_focus()
        && ui.input(|i| i.key_pressed(Key::Enter))
    {
        if let Err(e) = dashboard.reload_den() {
            // TODO user-facing error
            log::error!("Unable to load den: {e}");
        }
    };
    let button = ui.button("⟳");
    if button.clicked() {
        if let Err(e) = dashboard.reload_den() {
            // TODO user-facing error
            log::error!("Unable to load den: {e}");
        }
    }
    button.on_hover_text("Refresh den");
}
