amends "lib/simple-command.pkl"

name = "hg.command.bundle"
copy_data_env = false

command="""
    hg -R "$MAIN_REPO" bundle $BUNDLE_TYPE $REV_SELECT /dev/null
    """

environment {
    ["MAIN_REPO"] = "DATA-VARS:mercurial.main-repo-path"
}

variants {
    ["type"] {
        default_key = "default"
        cases {
            ["default"] {
                environment {
                    ["BUNDLE_TYPE"] = ""
                }
            }
            for (v in List("v1", "v2", "v3", "streamv2", "streamv3")){
                ["none-\(v)"] {
                    environment {
                        ["BUNDLE_TYPE"] = "--type none-\(v)"
                    }
                }
            }
        }
    }
    ["revs"] {
        default_key = "last-10000-exact"
        cases {
            ["all"] {
                environment {
                    ["REV_SELECT"] = "--all"
                }
            }
            for (r in List(1, 10, 100, 1000, 10000, 100000)){
                ["last-\(r)-exact"] {
                    environment {
                        ["REV_SELECT"] = "--exact --rev \(r)"
                    }
                }
            }
        }
    }
}
