amends "lib/simple-command.pkl"
import "lib/variants.pkl" as v

name="hg.command.clone"
copy_data_env = true


command="hg clone $ISSUE6528_ARG $PULLED_DELTA_REUSE_CFG `cat SOURCE` temporary-clone-destination"

prepare_run = """
    rm -rf temporary-clone-destination
    rm -rf SOURCE
    hg -R $MAIN_REPO debugupdatecache

    if [ "$PROTO" = "local-hardlink" ]; then
      echo $MAIN_REPO > SOURCE
    else if [ "$PROTO" = "local-pull" ]; then
      echo "--pull $MAIN_REPO" > SOURCE
    else if [ "$PROTO" = "ssh-pull" ]; then
      echo "--pull ssh://localhost/$PWD/$MAIN_REPO" > SOURCE
    else if [ "$PROTO" = "ssh-stream" ]; then
      echo "--stream ssh://localhost/$PWD/$MAIN_REPO" > SOURCE
    fi
    fi
    fi
    fi
    hg -R $MAIN_REPO log --rev "heads(all())" -T '--rev {node} ' > OUT_NODES.txt
    echo "hg clone $ISSUE6528_ARG $PULLED_DELTA_REUSE_CFG `cat SOURCE` temporary-clone-destination"
    """

environment {
    ["MAIN_REPO"] = "DATA-VARS:mercurial.main-repo-path"
}

variants {
    ["issue6528"] = v.simple_command["issue6528"]
    ["pulled-delta-reuse-policy"] = v.simple_command["pulled-delta-reuse-policy"]
    ["explicit-rev"] = v.simple_command["exchange-explicit-rev"]
    ["protocol"] {
        default_key = "local-pull"
        cases {
            for (p in List(
                "local-pull",
                "local-hardlink",
                "ssh-pull",
                "ssh-stream"
            )) {
                [p] {
                    environment {
                        ["PROTO"] = p
                    }
                    when (p.contains("ssh")) {
                        extend_command = """
                             --config ui.remotecmd="$POULPE_SSH_REMOTE_HG"
                            """
                    }
                }
            }
        }
    }
    ["validate"] = v.simple_command["validate-incoming"]
    ["resource-usage"] = v.simple_command["resource-usage"]
}
