amends "lib/perf.pkl"
import "lib/variants.pkl" as v

name = "hg.perf.exchange.stream.consume"

copy_data_env = true

command = "perf::stream-consume"
cwd = "DATA-VARS:mercurial.main-repo-path"
args {
    "../tmp-bundle.hg"
}

variants {
    ["version"] {
        default_key = "v2"
        cases {
            ["v2"] {
                setup_script = #"""
                               hg bundle --all \
                                    --type "none-v2;stream=v2" \
                                    ../tmp-bundle.hg
                               """#
            }
            ["v3"] {
                setup_script = #"""
                               hg bundle --all \
                                    --type "none-v2;stream=v3-exp"
                                    --config experimental.stream-v3=yes
                                    ../tmp-bundle.hg
                               """#
            }
        }
    }
    ["progress"] {
        default_key = "no"
        cases {
            ["yes"] { args { "--unbundle-progress" } }
            ["no"] { args { "--no-unbundle-progress" } }
        }
    }
    ["parallel-processing"] {
        default_key = "default"
        cases {
            ["default"] {}
            for (value in List("yes","no")) {
                [value] {
                    args {
                        "--config"
                        "worker.parallel-stream-bundle-processing=\(value)"
                    }
                }
            }
        }
    }
    ["num-writer"] {
        default_key = "default"
        cases {
            ["default"] {}
            for (value in List("1", "2", "3", "4", "8", "16", "32")) {
                [value] {
                    args {
                        "--config"
                        "worker.parallel-stream-bundle-processing.num-writer=\(value)"
                    }
                }
            }
        }
    }
    ["memory-target"] {
        default_key = "default"
        cases {
            ["default"] {}
            ["unlimited"] {
                args {
                    "--config"
                    "worker.parallel-stream-bundle-processing.memory-target=-1"
                }
            }
            for (value in List("10MB", "100MB", "1GB", "4GB")) {
                [value] {
                    args {
                        "--config"
                        "worker.parallel-stream-bundle-processing.memory-target=\(value)"
                    }
                }
            }
        }
    }
    ["read-from-memory"] {
        default_key = "no"
        cases {
            ["yes"] { args { "--in-memory-bundle" } }
            ["no"] { args { "--no-in-memory-bundle" } }
        }
    }
    ["resource-usage"] = v.perf["resource-usage"]
    ["resources-memory"] = v.perf["resources-memory"]
    ["resources-disk"] = v.perf["resources-disk"]
    ["resources-cpu"] = v.perf["resources-cpu"]
}
