amends "lib/simple-command.pkl"
import "lib/variants.pkl" as v

name="hg.command.pull"

copy_data_env = true

command="""
    hg pull $ISSUE6528_ARG $PULLED_DELTA_REUSE_CFG -R temporary-pull-local
    """
prepare_run = """
    if [ ! -d temporary-pull-remote ]; then
        hg -R $MAIN_REPO debugupdatecache;
        cp --archive --recursive --reflink=auto "$MAIN_REPO" temporary-pull-remote;
        hg -R temporary-pull-remote update null
        if declare -p BUNDLE_PATH &> /dev/null; then
            hg -R temporary-pull-remote unbundle $BUNDLE_PATH
        fi
        hg -R temporary-pull-remote debugupdatecache;
        hg -R "$MAIN_REPO" log --rev tip -T '{node}\n' > LAST_COMMON.txt
        hg -R temporary-pull-remote log --rev "heads(nodefromfile(LAST_COMMON.txt):)" -T '--rev {node} ' > OUT_NODES.txt
    fi
    rm -rf temporary-pull-local
    cp --archive --recursive --reflink=auto "$MAIN_REPO" temporary-pull-local;
    echo '[paths]' >> temporary-pull-local/.hg/hgrc
    if  [ $PROTO == "ssh" ]; then
        echo "default=ssh://localhost/$PWD/temporary-pull-remote" >> temporary-pull-local/.hg/hgrc
    else
        echo "default=../temporary-pull-remote" >> temporary-pull-local/.hg/hgrc
    fi
    """
environment {
    ["MAIN_REPO"] = "DATA-VARS:mercurial.main-repo-path"
}


variants {
    ["issue6528"] = v.simple_command["issue6528"]
    // XXX we should also use ["reuse-external-delta-parents"] = v.simple_command["reuse-external-delta-parent"]
    ["pulled-delta-reuse-policy"] = v.simple_command["pulled-delta-reuse-policy"]
    ["revs"] = (v.simple_command["bundled-revs"]) {
        default_key = "any-1000-extra-rev"
        cases {
            ["none"] {}
        }
    }
    ["explicit-rev"] = v.simple_command["exchange-explicit-rev"]
    ["protocol"]  = v.simple_command["protocol"]
    ["validate"] = v.simple_command["validate-incoming"]
    ["resource-usage"] = v.simple_command["resource-usage"]
}
