amends "lib/simple-command.pkl"
import "lib/variants.pkl" as v

name="hg.command.push"

copy_data_env = true

command="hg push --force $ISSUE6528_ARG $PULLED_DELTA_REUSE_CFG -R temporary-push-local"
prepare_run = """
    if [ ! -d temporary-push-local ]; then
        hg -R $MAIN_REPO debugupdatecache;
        cp --archive --recursive --reflink=auto "$MAIN_REPO" temporary-push-local;
        if declare -p BUNDLE_PATH &> /dev/null; then
            hg -R temporary-push-local unbundle $BUNDLE_PATH
        fi
        echo '[paths]' >> temporary-push-local/.hg/hgrc
        if  [ $PROTO == "ssh" ]; then
            echo "default=ssh://localhost/$PWD/temporary-push-remote" >> temporary-push-local/.hg/hgrc
        else
            echo "default=../temporary-push-remote" >> temporary-push-local/.hg/hgrc
        fi
        hg -R temporary-push-local debugupdatecache;
        hg -R "$MAIN_REPO" log --rev tip -T '{node}\n' > LAST_COMMON.txt
        hg -R temporary-push-local log --rev "heads(nodefromfile(LAST_COMMON.txt):)" -T '--rev {node} ' > OUT_NODES.txt
    fi
    rm -rf temporary-push-remote
    hg -R "$MAIN_REPO" update null
    cp --archive --recursive --reflink=auto "$MAIN_REPO" temporary-push-remote;
    echo "$ISSUE6528_CONFIG" >> temporary-push-remote/.hg/hgrc
    echo "$DELTA_PARENT_CONFIG" >> temporary-push-remote/.hg/hgrc
    """
environment {
    ["MAIN_REPO"] = "DATA-VARS:mercurial.main-repo-path"
}

variants {
    ["issue6528"] = v.simple_command["issue6528-config"]
    ["reuse-external-delta-parent"] = v.simple_command["reuse-external-delta-parent-config"]
    ["revs"] = (v.simple_command["bundled-revs"]) {
        default_key = "any-1000-extra-rev"
        cases {
            ["none"] {
                acceptable_return_codes {
                    1
                }
            }
        }
    }
    ["explicit-rev"] = v.simple_command["exchange-explicit-rev"]
    ["protocol"]  = v.simple_command["protocol"]
    ["validate"] = v.simple_command["validate-incoming"]
    ["resource-usage"] = v.simple_command["resource-usage"]
}
