amends "lib/simple-command.pkl"
import "lib/variants.pkl" as v

name = "hg.command.unbundle"
copy_data_env = true

command = """
    hg -R "./temporary-unbundle-destination" $UNBUNDLE_CMD $BUNDLE_PATH
    """
prepare_run = """
    rm -rf temporary-unbundle-destination;
    hg -R "$MAIN_REPO" update null
    hg -R "$MAIN_REPO" debugupdatecache
    cp --archive --recursive --reflink=auto "$MAIN_REPO" temporary-unbundle-destination
    echo "$ISSUE6528_CONFIG" >> temporary-unbundle-destination/.hg/hgrc
    echo "$DELTA_PARENT_CONFIG" >> temporary-unbundle-destination/.hg/hgrc
    """

environment {
    ["MAIN_REPO"] = "DATA-VARS:mercurial.main-repo-path"
}

variants {
    ["verbosity"] = (v.simple_command["verbosity"]) {
        default_key = "quiet"
    }
    ["issue6528"] = v.simple_command["issue6528-config"]
    ["reuse-external-delta-parent"] = v.simple_command["reuse-external-delta-parent-config"]
    ["source"] {
        default_key = "unbundle"
        cases {
            ["unbundle"] {
                environment {
                    ["UNBUNDLE_CMD"] = "unbundle"
                }
            }
            ["push"] {
                environment {
                    ["UNBUNDLE_CMD"] = "debug::unbundle"
                }
                constraints {
                    compatible_revision_range = "e2dfa403452d::"
                }
            }
        }
    }

    ["revs"] = (v.simple_command["bundled-revs"]) {
        default_key = "any-10000-extra-rev"
    }
    ["validate"] = v.simple_command["validate-incoming"]
    ["resource-usage"] = v.simple_command["resource-usage"]
}
