amends "lib/simple-command.pkl"

name = "hg.command.update"

copy_data_env = true

command="""
    hg $ATOMIC_UPDATE_CFG $WORKER_CFG update -R "$MAIN_REPO" $UPDATE_DESTINATION
    """
prepare_run = """
    hg update -R "$MAIN_REPO" $UPDATE_SOURCE --clean
    """
environment {
    ["MAIN_REPO"] = "DATA-VARS:mercurial.main-repo-path"
}

variants {
    ["scenario"] {
        default_key = "null-to-tip"
        cases {
            ["null-to-tip"]{
                environment {
                    ["UPDATE_SOURCE"] = "null"
                    ["UPDATE_DESTINATION"] = "tip"
                }
            }
            ["tip-to-null"]{
                environment {
                    ["UPDATE_SOURCE"] = "tip"
                    ["UPDATE_DESTINATION"] = "null"
                }
            }
            for (r in List(1, 10, 100, 1000, 10000)) {
                ["\(r)-rev-to-tip"] {
                    environment {
                        ["UPDATE_SOURCE"] = "tip~\(r)"
                        ["UPDATE_DESTINATION"] = "tip"
                    }
                    constraints {
                        graph {
                            visible_revision_count {
                                min=r
                            }
                        }
                    }
                }
            }
        }
    }
    ["atomic-update"] {
        default_key = "no"
        cases {
            ["no"]{
                environment {
                    ["ATOMIC_UPDATE_CFG"] = "--config experimental.update.atomic-file=no"
                }
            }
            ["yes"] = (this["no"]) {
                environment {
                    ["ATOMIC_UPDATE_CFG"] = super["ATOMIC_UPDATE_CFG"].replaceLast("=no", "=yes")
                }
            }
        }
    }
    ["worker"] {
        default_key = "default"
        cases {
            ["default"] {}
            ["no"] {
                environment {
                    ["WORKER_CFG"] = "--config worker.enabled=no"
                }
            }
            for (p in IntSeq(0, 6)){
                ["\(2**p)"] {
                    environment {
                        ["WORKER_CFG"] = "--config worker.enabled=yes --config worker.numcpus=\(2**p)"
                    }
                }
            }
        }
    }
}
