// This is far from perfect, but writing it already giving me many improvement
// idea, so that step in the right direction.
amends "campaign.pkl"



// should actually make use of `mercurial.repo.format` value, but keeping things for now.
local all_repos: Listing<String>(isDistinct) = new {
    "mercurial-devel-2024-03-22-zstd-sparse-revlog"
    "mercurial-devel-2024-03-22-ds2-pnm"
    "pypy-2018-08-01-zstd-sparse-revlog"
    "pypy-2018-08-01-ds2-pnm"
    "tryton-public-2024-03-22-zstd-sparse-revlog"
    "tryton-public-2024-03-22-ds2-pnm"
    // one very large repository with many drafts
    "mozilla-try-2023-03-22-zstd-sparse-revlog"
    "mozilla-try-2023-03-22-ds2-pnm"
    // cover a few repository more throughfully
    "mercurial-public-2024-03-22-zlib-general-delta"
    "mercurial-public-2024-03-22-zlib-sparse-revlog"
    "mercurial-public-2024-03-22-zstd-sparse-revlog"
    "mercurial-public-2024-03-22-ds2-pnm"
    "mozilla-unified-2024-03-22-zlib-sparse-revlog"
    "mozilla-unified-2024-03-22-zstd-sparse-revlog"
    "mozilla-unified-2024-03-22-ds2-pnm"
}
local any_data: Listing<DataEnvFilter> = new {
    for (name in all_repos.toList().filter((n) -> !n.contains("-ds2-"))) {
        new {
            key = "name"
            value = "re:^\(name)$"
        }
    }
}
local rust_only_data: Listing<DataEnvFilter> = new {
    for (name in all_repos.toList().filter((n) -> n.contains("-ds2-"))) {
        new {
            key = "name"
            value = "re:^\(name)$"
        }
    }
}


// "hg.command.pull"
// "hg.command.push"
// "hg.command.update"

local base_versions: Listing<VersionSpec> =  new {
    new {
        mercurial_flavor="no-rust"
    }
    new {
        mercurial_flavor="rust"
    }
}

local exchange_variants: Listing<BenchmarkVariantFilter> = new {
    new { key = "revs"; value = "any-1000-extra-rev" }
}
local bundle_variants: Listing<BenchmarkVariantFilter> = new {
    new { key = "type"; value = "none-v3" }
    ...exchange_variants
}

local incoming_variants: Listing<BenchmarkVariantFilter> = new {
    new { key = "issue6528"; value = "disabled" }
    new { key = "resource-usage"; value = "high" }
    // the "reading delta" part will be tested by log and update
    new { key = "validate"; value = "no" }
    new { key = "reuse-external-delta-parent"; value = "yes" }
}

local base_tasks: Listing<TaskSpec> = new {
    new {
        versions = base_versions
        benchmark_name_specs {
            new { value = "hg.command.bundle" }
        }
        benchmark_variant_specs = bundle_variants
    }
    new {
        versions = base_versions
        benchmark_name_specs {
            new { value = "hg.command.unbundle" }
        }
        benchmark_variant_specs {
            ...bundle_variants
            ...incoming_variants
        }
    }
    local exc_base: TaskSpec = new {
        versions = base_versions
        benchmark_variant_specs {
            new { key = "protocol"; value = "ssh" }
            ...exchange_variants
            ...incoming_variants
        }
    }
    (exc_base) {
        benchmark_name_specs {
            new { value = "hg.command.push" }
        }
    }
    (exc_base) {
        benchmark_name_specs {
            new { value = "hg.command.pull" }
        }
    }
    local files_base: TaskSpec = new {
        versions = (base_versions) {
            new { mercurial_flavor="rhg" }
        }
        benchmark_variant_specs {
            new { key = "rev"; value = "tip" }
            new { key = "files"; value = "all-root" }
        }
    }
    (files_base) {
        benchmark_name_specs {
            new { value = "hg.command.files" }
        }
    }
    (files_base) {
        benchmark_name_specs {
            new { value = "hg.command.cat" }
        }
    }
    new {
        versions = base_versions
        benchmark_name_specs {
            new { value = "hg.command.log" }
        }
        benchmark_variant_specs {
            new { key = "limit-rev"; value = "re:^1(000)?$" }
            new { key = "patch"; value = "re:^(no|yes)$" }
        }
    }
    new {
        versions = base_versions
        benchmark_name_specs {
            new { value = "hg.command.update" }
        }
        benchmark_variant_specs {
            new { key = "scenario"; value = "re:^null-to-tip|100-rev-to-tip$" }
        }
    }
}


local function rust_only(versions: Listing<VersionSpec>): Listing<VersionSpec> = (
    versions
    .toList()
    .filter(
        (v) -> (
            v.mercurial_flavor == "rust"
            || v.mercurial_flavor == "rhg"
        )
    ).toListing()
)


// use only the rust flavor on the rust repositories
tasks {
    for (t in base_tasks) {
        for (d in any_data) {
            (t) { data_env_specs {d} }
        }
        for (d in rust_only_data) {
            (t) {
                versions = rust_only(super.versions)
                data_env_specs {d}
            }
        }
    }
}
