#!/bin/bash
#
# Simple script to record a directory containing a mercurial clone as a data-env
#
# You still have to build the env by hand.
set -Eeuo pipefail

if [ $# -ne 3 ]; then
    echo >&2 "USAGE: setup-00-minimal.sh ENV-NAME DATA-ENV-PATH REPO-PATH"
    echo >&2 "  ENV-NAME:      the name that will be recorded for the data-env"
    echo >&2 "  DATA-ENV-PATH: the path to that data-env"
    echo >&2 "  REPO-PATH:     the path of the main repository within that data-env"
    exit 32
fi

env_name=$1
data_env_directory=$2
repository_path=$3

repo="${data_env_directory}/${repository_path}"

desc="${data_env_directory}/data-env.poulpe"

poulpe env-desc set "$desc" poulpe-environment.environment-type data
poulpe env-desc set "$desc" poulpe-environment.format-version 0
poulpe env-desc set "$desc" poulpe-environment.setup-method manual
poulpe env-desc set "$desc" data-env-vars.name "$env_name"
poulpe env-desc set "$desc" bench-input-vars.mercurial.main-repo-path "$repository_path"
