#!/bin/bash
#
# Simple script to record the format variant of a data-envs
#
# This only record the variant of the main repository. The side repository are
# assumed to have the format.
#
# You still have to build the env by hand.
set -Eeuo pipefail

if [ $# -ne 1 ]; then
    echo >&2 "USAGE: setup-10-format.sh DATA-ENV-PATH"
    echo >&2 "  DATA-ENV-PATH: the path to that data-env"
    exit 32
fi

data_env_directory=$1
desc="${data_env_directory}/data-env.poulpe"

repository_path="`poulpe env-desc get "$desc" bench-input-vars.mercurial.main-repo-path`"

repo="$data_env_directory/$repository_path"

for line in `hg debugformat -R $repo | sed 's/: \+/;/' | grep -v '  '`; do
    poulpe env-desc set "$desc" data-env-vars.mercurial.repo.format.`echo $line | sed 's/;/ /'`
done

cat <<EOF >> "$repo/.hg/hgrc"
[storage]
revlog.persistent-nodemap.slow-path = allow
dirstate-v2.slow-path = allow
EOF
