#!/bin/bash
#
# Simple script to record the most interesting files for benchmarking annotate
#
# You still have to build the env by hand.
set -Eeuo pipefail

if [ $# -ne 1 ]; then
    echo >&2 "USAGE: setup-70-annotate.sh DATA-ENV-PATH"
    echo >&2 "  DATA-ENV-PATH: the path to that data-env"
    exit 32
fi

data_env_directory=$1
desc="${data_env_directory}/data-env.poulpe"

repository_path="$(poulpe env-desc get "$desc" bench-input-vars.mercurial.main-repo-path)"

repo="$data_env_directory/$repository_path"

INDEX=0

suffixes=("a" "b" "c" "d" "e")

for filename in $(
    hg -R "$repo" debug-revlog-stats -f | \
        tail -n +2 | \
        awk '{print $1, $5}' | \
        sort -n | \
        tail -n 5 | \
        cut -f2 -d' ' | \
        tac
    ); do
    poulpe env-desc set "$desc" \
        "bench-input-vars.mercurial.file-with-long-history.${suffixes[INDEX]}" \
        "$filename"
    ((INDEX=INDEX+1))
done
