==============================
Test the listing of Benchmarks
==============================

  $ . $TESTDIR/testlib/base-test-setup.sh
  $ SRC_DIR=$TESTDIR/..

Setup a Den
-----------

  $ $PYTHON $SRC_DIR/bin/setup-poulpe-den listing-test-den
  Creating folders
  Create symlinks to Poulpe
  Installing poulpe (editable) into a new venv
  Creating a "bin/" directory with a few utilities
  Cloning repositories to benchmark
  Updating environment variables
  Poulpe Den ready to use in "$TESTTMP/listing-test-den"
  Run . "$TESTTMP/listing-test-den/bin/activate" to activate the environment
  $ cd listing-test-den
  $ . bin/activate


reduce the amount of test we have to deal with to stabilize this test

  $ ls -l benchmarks
  total * (glob)
  * hg -> ../tooling/poulpe/suites/hg/benchmarks (glob)
  * swh -> ../tooling/poulpe/suites/swh/benchmarks (glob)
  $ rm benchmarks/hg
  $ mkdir benchmarks/hg
  $ cp tooling/poulpe/suites/hg/benchmarks/*bundle.pbd benchmarks/hg
  $ cp tooling/poulpe/suites/hg/benchmarks/status.pbd benchmarks/hg
  $ cp tooling/poulpe/suites/hg/benchmarks/debug-update-cache.pbd benchmarks/hg
  $ cp tooling/poulpe/suites/hg/benchmarks/debug-revlog-index.pbd benchmarks/hg

Test listing itself
===================

vanillia run
------------

  $ poulpe den-list-benchmarks
  hg.command.bundle
  hg.command.status
  hg.command.unbundle
  hg.debug.debug-revlog-index
  hg.debug.debug-update-cache
  hg.perf.perf-bundle
  hg.perf.unbundle
  swh.git-loader.from-disk.in-memory
  swh.git-loader.from-disk.postgres

Showing path
------------

  $ poulpe den-list-benchmarks --show-path
  hg.command.bundle
   benchmarks/hg/bundle.pbd
  hg.command.status
   benchmarks/hg/status.pbd
  hg.command.unbundle
   benchmarks/hg/unbundle.pbd
  hg.debug.debug-revlog-index
   benchmarks/hg/debug-revlog-index.pbd
  hg.debug.debug-update-cache
   benchmarks/hg/debug-update-cache.pbd
  hg.perf.perf-bundle
   benchmarks/hg/perf-bundle.pbd
  hg.perf.unbundle
   benchmarks/hg/perf-unbundle.pbd
  swh.git-loader.from-disk.in-memory
   benchmarks/swh/from-disk-in-memory.pbd
  swh.git-loader.from-disk.postgres
   benchmarks/swh/from-disk-postgres.pbd

listing variants
----------------

  $ poulpe den-list-benchmarks --list-variants
  hg.command.bundle
    * revs:
      - all
      - last-1-exact
      - last-10-exact
      - last-100-exact
      - last-1000-exact
      - last-10000-exact (default)
      - last-100000-exact
    * type:
      - default (default)
      - none-v1
      - none-v2
      - none-v3
      - none-streamv2
      - none-streamv3
  hg.command.status
    * list-copies:
      - no (default)
      - yes
    * listed:
      - default (default)
      - all
      - mard
      - mardu
      - mardui
      - a
    * range:
      - working-copy (default)
      - change-tip
      - change-1000th-tiprev
      - change-1000th-rev
      - from-null-to-tip
      - from-tip-to-null
      - from-rev-0-to-tip
      - from-1000th-tiprev-to-tip
      - from-null-to-1000th
      - from-rev-0-to-1000th
      - from-null
      - from-tip
      - from-rev-0
      - from-1000th-tiprev
    * repo-state:
      - modified
      - clean (default)
      - large-ignored
      - large-all
      - ignored
      - ignored-unknowns
      - all-and-large-ignored
      - large-modified
      - large-modified-and-copied
      - modified-and-copied
  hg.command.unbundle
    * issue6528:
      - default (default)
      - fix-incoming
      - disabled
    * resource-usage:
      - default (default)
      - high
      - medium
      - low
    * reuse-external-delta-parent:
      - default (default)
      - yes
      - no
    * revs:
      - any-1-extra-rev
      - any-10-extra-rev
      - any-100-extra-rev
      - any-1000-extra-rev
      - any-10000-extra-rev (default)
      - any-100000-extra-rev
    * source:
      - unbundle (default)
      - push
    * validate:
      - default (default)
      - no
      - yes
    * verbosity:
      - quiet (default)
      - standard
      - verbose
      - debug
  hg.debug.debug-revlog-index
    * revlog:
      - changelog
      - manifestlog (default)
  hg.debug.debug-update-cache
    * pre-state:
      - warm (default)
      - no-hgtags-fnodes
      - no-rev-branch-cache
  hg.perf.perf-bundle
    * revs:
      - last-100000
      - last-40000 (default)
      - last-10000
      - last-1000
      - last-100
      - last-10
      - last-1
  hg.perf.unbundle
    * issue6528:
      - default (default)
      - fix-incoming
      - disabled
    * revs:
      - any-1-extra-rev
      - any-10-extra-rev
      - any-100-extra-rev
      - any-1000-extra-rev
      - any-10000-extra-rev (default)
      - any-100000-extra-rev
    * source:
      - default (default)
      - push
  swh.git-loader.from-disk.in-memory
  swh.git-loader.from-disk.postgres
    * preload:
      - none (default)
      - all

with a patterns
--------------

One pattern

  $ poulpe den-list-benchmarks hg.perf
  hg.perf.perf-bundle
  hg.perf.unbundle

multiple pattern

  $ poulpe den-list-benchmarks hg.perf hg.debug
  hg.debug.debug-revlog-index
  hg.debug.debug-update-cache
  hg.perf.perf-bundle
  hg.perf.unbundle

regex pattern

  $ poulpe den-list-benchmarks 're:.*bundle$'
  hg.command.bundle
  hg.command.unbundle
  hg.perf.perf-bundle
  hg.perf.unbundle

