Test the utility to setup data environment
------------------------------------------

  $ . $TESTDIR/testlib/base-test-setup.sh
  $ python -m venv $TESTTMP/
  $ . $TESTTMP/bin/activate
# pip is apparently unable to have multiple instance installing from the same
# directory at the same time, so we do a local copy first ☹
  $ cp -aR  $TESTDIR/.. poulpe-dir
  $ pip install ./poulpe-dir/ --quiet
  $ rm -rf poulpe-dir


This tests the data setup script for Mercurial.

  $ SETUP_PATH="${TESTDIR}/../suites/hg/data-env-setup/"


Basic manual setup of the data-env data

  $ mkdir my-data-env
  $ hg init my-data-env/base-repo/
  $ hg -R my-data-env/base-repo/ debugbuilddag --new-file \
  > '.:z'\
  > '+1309:a'\
  > '<z+1177:b/a'\
  > '+1033:c'\
  > '<b+1330:d/c'\
  > '+1395:e'\
  > '<a+1081:f'\
  > '<b+1070:g/e'\
  > '+1081:h/f'\
  > '+1083:i'\
  > '<c+1226:j/f'
  $ cd my-data-env/base-repo/
  $ cat << EOF > .hgignore
  > ^ignored.*
  > EOF
  $ seq 20 | xargs -I {} touch "clean-{}"
  $ seq 20 | xargs -I {} touch "modified-{}"
  $ seq 20 | xargs -I {} touch "removed-{}"
  $ seq 20 | xargs -I {} touch "deleted-{}"
  $ seq 20 | xargs -I {} touch "copies-{}"
  $ hg commit -Aqm "add files"
  $ touch other
  $ hg commit -Aqm "add another revision to check update mechanism"

  $ cd ../..


Create the data-brick for the status/working-copy tests

  $ mkdir data-brick

  $ seq 20 | xargs -I {} echo "ignored-{}" > data-brick/large-ignored.list
  $ seq 10 | xargs -I {} echo "ignored-{}" > data-brick/ignored.list
  $ seq 10 | xargs -I {} echo "unknown-{}" > data-brick/unknowns.list
  $ seq 4 | xargs -I {} echo "added-{}" > data-brick/added.list
  $ seq 20 | xargs -I {} echo "modified-{}" > data-brick/modified.list
  $ seq 3 | xargs -I {} echo "removed-{}" > data-brick/removed.list
  $ seq 20 | xargs -I {} echo "deleted-{}" > data-brick/deleted.list
  $ seq 5 | xargs -I {} printf 'copies-%s\0target-%s\n' {} {} > data-brick/copied.list
  $ "${SETUP_PATH}"/../make-working-copy-brick data-brick 89a671d559cc --brick-name my-data-brick 
  
  Successfully written to 'data-brick/data-brick.poulpe'.

  $ cd data-brick
  $ tar cf ../my-brick.tar .
  $ cd ..


Test the full setup
--------------------

  $ "${SETUP_PATH}"/setup-full.py my-data-env --repo base-repo --name "my-test-data-env" --wc-brick my-brick.tar
  Creating the base data-env
  creating new file: "$TESTTMP/my-data-env/data-env.poulpe"
  Registering graph details
  Registering the format details
  Setting up working-copy benchmarks
  Unpacking brick my-brick.tar
  Updating to revision 89a671d559cc
  Copying repo $TESTTMP/my-data-env/base-repo to b'$TESTTMP/my-data-env/base-repo-mercurial.working-copy.all-and-large-ignored'
  Updating to revision 89a671d559cc
  Applying poulpe::create-files with params {'files_list': 'added.list'}
  Applying hg::working-copy.add-files with params {'files_list': 'added.list'}
  Applying hg::working-copy.copy-files with params {'files_pairs_list': 'copied.list'}
  Applying poulpe::delete-files with params {'files_list': 'deleted.list'}
  Applying poulpe::create-files with params {'files_list': 'large-ignored.list'}
  Applying poulpe::modify-files with params {'files_list': 'modified.list'}
  Applying hg::working-copy.remove-files with params {'files_list': 'removed.list'}
  Applying poulpe::create-files with params {'files_list': 'unknowns.list'}
  Copying repo $TESTTMP/my-data-env/base-repo to b'$TESTTMP/my-data-env/base-repo-mercurial.working-copy.ignored'
  Updating to revision 89a671d559cc
  Applying poulpe::create-files with params {'files_list': 'ignored.list'}
  Copying repo $TESTTMP/my-data-env/base-repo to b'$TESTTMP/my-data-env/base-repo-mercurial.working-copy.ignored-unknowns'
  Updating to revision 89a671d559cc
  Applying poulpe::create-files with params {'files_list': 'ignored.list'}
  Applying poulpe::create-files with params {'files_list': 'unknowns.list'}
  'large-all' requires missing lists: '['large-added', 'large-copied', 'large-deleted', 'large-modified', 'large-removed', 'large-unknowns']', skipping.
  Copying repo $TESTTMP/my-data-env/base-repo to b'$TESTTMP/my-data-env/base-repo-mercurial.working-copy.large-ignored'
  Updating to revision 89a671d559cc
  Applying poulpe::create-files with params {'files_list': 'large-ignored.list'}
  'large-modified' requires missing lists: '['large-modified']', skipping.
  'large-modified-and-copied' requires missing lists: '['large-copied', 'large-modified']', skipping.
  Copying repo $TESTTMP/my-data-env/base-repo to b'$TESTTMP/my-data-env/base-repo-mercurial.working-copy.modified'
  Updating to revision 89a671d559cc
  Applying poulpe::modify-files with params {'files_list': 'modified.list'}
  Copying repo $TESTTMP/my-data-env/base-repo to b'$TESTTMP/my-data-env/base-repo-mercurial.working-copy.modified-and-copied'
  Updating to revision 89a671d559cc
  Applying hg::working-copy.copy-files with params {'files_pairs_list': 'copied.list'}
  Applying poulpe::modify-files with params {'files_list': 'modified.list'}
  Setting up `delta-find` benchmark (can take a very long time)
  Setting up `annotate` benchmark (can take up to a few minutes)

  $ cd my-data-env
  $ poulpe env-desc show data-env.poulpe
  applied-bricks:
    my-data-brick:
    - mercurial.working-copy.all-and-large-ignored
    - mercurial.working-copy.ignored
    - mercurial.working-copy.ignored-unknowns
    - mercurial.working-copy.large-ignored
    - mercurial.working-copy.modified
    - mercurial.working-copy.modified-and-copied
  bench-input-vars:
    mercurial:
      file-with-long-history:
        a = removed-9
        b = removed-8
        c = removed-7
        d = removed-6
        e = removed-5
      main-repo-path = base-repo
      revlog:
        delta-find:
          manifest:
            merge:
              long-chain-both:
                a = 11790
                b = 9480
                c = 8398
                d = 4851
                e = 2487
            snapshot:
              many-both:
                a = 8152
                b = 11355
                c = 6939
                d = 9151
                e = 4345
              many-rounds:
                a = 11355
                b = 9151
                c = 8152
                d = 6939
                e = 10152
              many-tries:
                a = 8152
                b = 11355
                c = 6939
                d = 9151
                e = 4345
      working-copy:
        all-and-large-ignored = base-repo-mercurial.working-copy.all-and-large-ignored
        clean = base-repo
        ignored = base-repo-mercurial.working-copy.ignored
        ignored-unknowns = base-repo-mercurial.working-copy.ignored-unknowns
        large-ignored = base-repo-mercurial.working-copy.large-ignored
        modified = base-repo-mercurial.working-copy.modified
        modified-and-copied = base-repo-mercurial.working-copy.modified-and-copied
        update-to-revision = 89a671d559cc
  data-env-vars:
    mercurial:
      repo:
        format:
          changelog-v2 = no
          compression = zstd
          compression-level = default
          copies-sdc = no
          dirstate-v2 = no
          dotencode = yes
          fncache = yes
          generaldelta = yes
          persistent-nodemap = yes (rust !)
          persistent-nodemap = no (no-rust !)
          plain-cl-delta = yes
          revlog-v2 = no
          share-safe = yes
          sparserevlog = yes
          tracked-hint = no
        graph:
          draft-visible-revision-count = 11793
          hidden-revision-count = 0
          non-public-visible-revision-count = 11793
          obsmarker-count = 0
          obsolete-hidden-revision-count = 0
          obsolete-visible-revision-count = 0
          secret-visible-revision-count = 11793
          visible-revision-count = 11793
    name = my-test-data-env
  poulpe-environment:
    environment-type = data
    format-version = 0
    setup-method = manual

Check status-specific things
============================

Check that we've updated to the correct revision on all repos

  $ hg id -R base-repo
  89a671d559cc
  $ hg id -R base-repo-mercurial.working-copy.large-ignored
  89a671d559cc
  $ hg id -R base-repo-mercurial.working-copy.all-and-large-ignored
  89a671d559cc+
  $ hg id -R base-repo-mercurial.working-copy.ignored
  89a671d559cc
  $ hg id -R base-repo-mercurial.working-copy.ignored-unknowns
  89a671d559cc

Check that each repo has the correct files applied

  $ count_types() {
  >   cut -c -1 | sort | uniq -c
  > }

  $ hg st -mardui --copies --cwd base-repo | count_types
  $ hg st -mardui --copies --cwd base-repo-mercurial.working-copy.large-ignored | count_types
       20 I
  $ hg st -mardui --copies --cwd base-repo-mercurial.working-copy.all-and-large-ignored | count_types
        5  
       20 !
       10 ?
        9 A
       20 I
       20 M
        3 R
  $ hg st -mardui --copies --cwd base-repo-mercurial.working-copy.ignored | count_types
       10 I
  $ hg st -mardui --copies --cwd base-repo-mercurial.working-copy.ignored-unknowns | count_types
       10 ?
       10 I
