#!/bin/bash
set -Eeuo pipefail

python3 -m venv .
bin/pip3 install --quiet black=="$BLACK_VERSION"

echo python.version="`bin/python --version | egrep -o '\S+$'`" > POULPE-VARS
echo black.version="`bin/black --version | egrep -o '\S+$'`" >> POULPE-VARS
echo black.install-method=pip >> POULPE-VARS

touch bin-env.shell
chmod +x bin-env.shell

cat >> bin-env.shell << EOF
#!/bin/bash
set -Eeuo pipefail
BIN_ENV_PATH="\`dirname \"\$0\"\`"
. "\$BIN_ENV_PATH"/bin/activate
"\$@"
EOF
