Test the small utility that access environment description
----------------------------------------------------------

  $ . $TESTDIR/testlib/base-test-setup.sh
  $ python -m venv $TESTTMP/
  $ . $TESTTMP/bin/activate
# pip is apparently unable to have multiple instance installing from the same
# directory at the same time, so we do a local copy first ☹
  $ cp -aR  $TESTDIR/.. poulpe-dir
  $ pip install ./poulpe-dir/ --quiet
  $ rm -rf poulpe-dir

Check basic error
----------------

no args

  $ poulpe env-desc
  Usage: env-desc [OPTIONS] COMMAND [ARGS]...
  
    Low-level utility to manipulate Poulpe description trees.
  
    Poulpe description trees are common to data-envs, bin-envs and benchmarks.
  
  Options:
    --help  Show this message and exit.
  
  Commands:
    del   Remove a key from the description tree.
    get   Display the value of a key from the description tree.
    set   Set a key of the description tree to a new value.
    show  Display the contents of the description tree.

too few args

  $ poulpe env-desc foo
  Usage: env-desc [OPTIONS] COMMAND [ARGS]...
  Try 'env-desc --help' for help.
  
  Error: No such command 'foo'.
  [2]

bad action

  $ poulpe env-desc foo bar
  Usage: env-desc [OPTIONS] COMMAND [ARGS]...
  Try 'env-desc --help' for help.
  
  Error: No such command 'foo'.
  [2]

missing GET key

  $ poulpe env-desc get no-file
  Usage: env-desc get [OPTIONS] PATH KEY
  Try 'env-desc get --help' for help.
  
  Error: Missing argument 'KEY'.
  [2]

missing SET key

  $ poulpe env-desc set no-file
  Usage: env-desc set [OPTIONS] PATH KEY VALUE
  Try 'env-desc set --help' for help.
  
  Error: Missing argument 'KEY'.
  [2]

missing SET value

  $ poulpe env-desc set no-file key
  Usage: env-desc set [OPTIONS] PATH KEY VALUE
  Try 'env-desc set --help' for help.
  
  Error: Missing argument 'VALUE'.
  [2]

missing DEL key

  $ poulpe env-desc del no-file
  Usage: env-desc del [OPTIONS] PATH KEY
  Try 'env-desc del --help' for help.
  
  Error: Missing argument 'KEY'.
  [2]

Missing file when reading

  $ poulpe env-desc show no-file
  missing file: "no-file"
  [3]

  $ poulpe env-desc get no-file no-key
  missing file: "no-file"
  [3]

Writing and reading files
-------------------------

Small and basic usage to smoke test the script

  $ poulpe env-desc set bin-env.pe vars.hg.version 6.1.0
  creating new file: "bin-env.pe"
  $ poulpe env-desc set bin-env.pe vars.hg.flavor pure
  $ poulpe env-desc set bin-env.pe vars.oops babar
  $ poulpe env-desc get bin-env.pe vars.hg.version
  6.1.0
  $ poulpe env-desc get bin-env.pe vars.hg.flavor
  pure
  $ poulpe env-desc get bin-env.pe vars.oops
  babar
  $ poulpe env-desc show bin-env.pe
  vars:
    hg:
      flavor = pure
      version = 6.1.0
    oops = babar

Modify the file more

  $ poulpe env-desc set bin-env.pe vars.hg.version 4.3.0
  $ poulpe env-desc del bin-env.pe vars.oops
  $ poulpe env-desc get bin-env.pe vars.hg.version
  4.3.0
  $ poulpe env-desc get bin-env.pe vars.hg.flavor
  pure
  $ poulpe env-desc get bin-env.pe vars.oops
  [1]
  $ poulpe env-desc show bin-env.pe
  vars:
    hg:
      flavor = pure
      version = 4.3.0
