

Check we have enough simple pieces together to do a simple run
--------------------------------------------------------------

  $ . $TESTDIR/testlib/base-test-setup.sh
  $ python -m venv $TESTTMP/
  $ . $TESTTMP/bin/activate
# pip is apparently unable to have multiple instance installing from the same
# directory at the same time, so we do a local copy first ☹
  $ cp -aR  $TESTDIR/.. poulpe-dir
  $ pip install ./poulpe-dir/ --quiet
  $ rm -rf poulpe-dir

Setup the bin-env
-----------------

  $ BLACK_VERSION="18.6b4" poulpe bin-env-util setup-one  bin-env-black-18.6b4 \
  > $TESTDIR/test-data/setup-black.sh
  $ poulpe bin-env-util show bin-env-black-18.6b4
  bin-env-vars:
    black:
      install-method = pip
      version = 18.6b4
    python:
      version = 3.* (glob)
  poulpe-environment:
    environment-type = binary
    format-version = 0
    setup-method = script
  ready = True


Setup a data-env
----------------

(currently built by hand as it simple and mostly innert)

  $ mkdir data-env
  $ poulpe env-desc set data-env/data-env.poulpe poulpe-environment.environment-type data
  creating new file: "data-env/data-env.poulpe"
  $ poulpe env-desc set data-env/data-env.poulpe poulpe-environment.format-version 0
  $ poulpe env-desc set data-env/data-env.poulpe poulpe-environment.setup-method manual
  $ poulpe env-desc set data-env/data-env.poulpe data-env-vars.name black-bench
  $ mkdir data-env/py-files
  $ cat << EOF > data-env/py-files/good.py
  > foo = [1, 2, 3, 4, 5]
  > EOF
  $ cat << EOF > data-env/py-files/bad.py
  > foo = [1,
  >    2,
  >   3,
  >     4,
  >  5]
  > EOF
  $ poulpe env-desc set data-env/data-env.poulpe bench-input-vars.black.check.tiny.good py-files/good.py
  $ poulpe env-desc set data-env/data-env.poulpe bench-input-vars.black.check.tiny.bad py-files/bad.py

(that one will be a string, so its not good.)

  $ poulpe env-desc set data-env/data-env.poulpe ready 1

  $ poulpe env-desc show data-env/data-env.poulpe
  bench-input-vars:
    black:
      check:
        tiny:
          bad = py-files/bad.py
          good = py-files/good.py
  data-env-vars:
    name = black-bench
  poulpe-environment:
    environment-type = data
    format-version = 0
    setup-method = manual
  ready = 1

Define a benchmark
------------------

  $ poulpe env-desc set black-tiny-bad.pbd meta.format 0
  creating new file: "black-tiny-bad.pbd"
  $ poulpe env-desc set black-tiny-bad.pbd meta.name black.check.tiny
  $ poulpe env-desc set black-tiny-bad.pbd meta.method simple-command
  $ poulpe env-desc set black-tiny-bad.pbd simple-command.command "black --check {file}"
  $ poulpe env-desc set --type json black-tiny-bad.pbd simple-command.acceptable-return-codes '[1]'
  $ poulpe env-desc set black-tiny-bad.pbd simple-command.variables.file DATA-VARS:black.check.tiny.bad
  $ poulpe env-desc set black-tiny-bad.pbd simple-command.cwd .

  $ poulpe env-desc show black-tiny-bad.pbd
  meta:
    format = 0
    method = simple-command
    name = black.check.tiny
  simple-command:
    acceptable-return-codes:
    - 1
    command = black --check {file}
    cwd = .
    variables:
      file = DATA-VARS:black.check.tiny.bad

Run the benchmark
-----------------
  $ poulpe run-util bin-env-black-18.6b4 data-env black-tiny-bad.pbd test-result-18.6b4-bad.pbr
  $ poulpe env-desc show test-result-18.6b4-bad.pbr
  benchmark:
    name = black.check.tiny
  bin-env-vars:
    black:
      install-method = pip
      version = 18.6b4
    python:
      version = 3.* (glob)
  data-env-vars:
    name = black-bench
  result:
    time:
      max = * (glob)
      mean = * (glob)
      median = * (glob)
      min = * (glob)
      standard-deviation = * (glob)
      system = * (glob)
      user = * (glob)
  run:
    duration = * (glob)
    timestamp = * (glob)

Run the benchmark with --debug
------------------------------

It should display details about the run and limit the number of iteration

  $ poulpe run-util --debug bin-env-black-18.6b4 data-env black-tiny-bad.pbd test-result-18.6b4-bad.pbr
  Benchmark 1: echo "### starting command ###" ; date ; black --check py-files/bad.py
  ### starting command ###
  ??? ??? * (glob)
  would reformat py-files/bad.py
  All done! * (glob)
  1 file would be reformatted.
  ### starting command ###
  ??? ??? * (glob)
  would reformat py-files/bad.py
  All done! * (glob)
  1 file would be reformatted.
    Time * (glob)
    Range * 2 runs (glob)
   
    Warning: Ignoring non-zero exit code.
   
  $ poulpe env-desc show test-result-18.6b4-bad.pbr
  benchmark:
    name = black.check.tiny
  bin-env-vars:
    black:
      install-method = pip
      version = 18.6b4
    python:
      version = 3.* (glob)
  data-env-vars:
    name = black-bench
  result:
    time:
      max = * (glob)
      mean = * (glob)
      median = * (glob)
      min = * (glob)
      standard-deviation = * (glob)
      system = * (glob)
      user = * (glob)
  run:
    duration = * (glob)
    timestamp = * (glob)
