============================================
Check the script that setup a base directory
============================================

  $ . $TESTDIR/testlib/base-test-setup.sh
  $ SRC_DIR=$TESTDIR/..

Run the script
--------------

  $ $PYTHON $SRC_DIR/bin/setup-poulpe-den benchmark-home
  Creating folders
  Create symlinks to Poulpe
  Installing poulpe (editable) into a new venv
  Creating a "bin/" directory with a few utilities
  Cloning repositories to benchmark
  Updating environment variables
  Poulpe Den ready to use in "$TESTTMP/benchmark-home"
  Run . "$TESTTMP/benchmark-home/bin/activate" to activate the environment

Check the resulting dir
=======================

  $ ls -1F benchmark-home
  benchmarks/
  bin/
  bin-envs/
  data-envs/
  repositories/
  results/
  suites@
  tooling/
  $ ls -l benchmark-home/benchmarks/
  total * (glob)
  * hg -> ../tooling/poulpe/suites/hg/benchmarks (glob)
  * swh -> ../tooling/poulpe/suites/swh/benchmarks (glob)

check `bin/` content
--------------------


The poulpe executable works

  $ benchmark-home/bin/poulpe
  Usage: poulpe [OPTIONS] COMMAND [ARGS]...
  
    The main entry point for Poulpe command
  
  Options:
    --help  Show this message and exit.
  
  Commands:
    bin-env-util                  use `poulpe bin-env-util --help` for details
    den-check                     Verify and Summarise the state of a...
    den-execute-tasks             execute the content of a schedule file
    den-generate-tasks            Generate a tasks list from parameters.
    den-interactive-bin-env-spec  Interactive command to guide you though...
    den-list-benchmarks           Find and list benchmarks available in a...
    den-list-bin-env-setups       Find and list automatic Binary...
    den-list-data-envs            Find and list Data Enviroment available...
    den-setup-bin-env             Setup a binary environment from the spec,...
    diff-result                   use `poulpe diff-result --help` for details
    env-desc                      use `poulpe env-desc --help` for details
    result-compare                Compare results together.
    result-search                 Find result files matching filters.
    run-util                      use `poulpe run-util --help` for details

The shell works

  $ benchmark-home/bin/shell poulpe
  Usage: poulpe [OPTIONS] COMMAND [ARGS]...
  
    The main entry point for Poulpe command
  
  Options:
    --help  Show this message and exit.
  
  Commands:
    bin-env-util                  use `poulpe bin-env-util --help` for details
    den-check                     Verify and Summarise the state of a...
    den-execute-tasks             execute the content of a schedule file
    den-generate-tasks            Generate a tasks list from parameters.
    den-interactive-bin-env-spec  Interactive command to guide you though...
    den-list-benchmarks           Find and list benchmarks available in a...
    den-list-bin-env-setups       Find and list automatic Binary...
    den-list-data-envs            Find and list Data Enviroment available...
    den-setup-bin-env             Setup a binary environment from the spec,...
    diff-result                   use `poulpe diff-result --help` for details
    env-desc                      use `poulpe env-desc --help` for details
    result-compare                Compare results together.
    result-search                 Find result files matching filters.
    run-util                      use `poulpe run-util --help` for details

We can activate the env

  $ . benchmark-home/bin/activate
  $ which poulpe
  $TESTTMP/benchmark-home/.venv/bin/poulpe
  $ echo $POULPE_BASE_DIR
  $TESTTMP/benchmark-home
  $ echo $HG_PERF_PATH
  $TESTTMP/benchmark-home/repositories/mercurial/contrib/perf.py
  $ deactivate

check repositories content
--------------------------

  $ ls benchmark-home/repositories
  mercurial
  swh-loader-git

Use the official check command
------------------------------

Check with a path argument

  $ benchmark-home/bin/poulpe den-check --den-path benchmark-home/
  script and tools:      [OKAY]
  binary environments:   [OKAY]
  data environments:     [OKAY]
    available: 0
  benchmarks:            [OKAY]
    available: 29
  results:               [OKAY]
  poulpe suites:         [OKAY]
    available bin setup: 2
  source repositories:   [OKAY]
  tooling and utilities: [OKAY]

Check withiout a path argument

  $ cd benchmark-home
  $ . bin/activate
  $ poulpe den-check
  script and tools:      [OKAY]
  binary environments:   [OKAY]
  data environments:     [OKAY]
    available: 0
  benchmarks:            [OKAY]
    available: 29
  results:               [OKAY]
  poulpe suites:         [OKAY]
    available bin setup: 2
  source repositories:   [OKAY]
  tooling and utilities: [OKAY]


  $ cd ..
