=====================================
Test the generation of benchmark Task
=====================================

  $ . $TESTDIR/testlib/base-test-setup.sh
  $ SRC_DIR=$TESTDIR/..

Setup a Den
-----------

  $ $PYTHON $SRC_DIR/bin/setup-poulpe-den running-test-den
  Creating folders
  Create symlinks to Poulpe
  Installing poulpe (editable) into a new venv
  Creating a "bin/" directory with a few utilities
  Cloning repositories to benchmark
  Updating environment variables
  Poulpe Den ready to use in "$TESTTMP/running-test-den"
  Run . "$TESTTMP/running-test-den/bin/activate" to activate the environment
  $ cd running-test-den
  $ . bin/activate

Setup some data-env
-------------------

XXX consider muting this

  $ "$TESTDIR/testlib/setup-test-data-env.sh" data-envs
  Creating the base data-env
  creating new file: "$TESTTMP/running-test-den/data-env-1/data-env.poulpe"
  Registering graph details
  Registering the format details
  Setting up working-copy benchmarks
  Warning: running setup-working-copy without a data brick
  (non-default working-copy variants will be unavailable)
  Setting up `delta-find` benchmark (can take a very long time)
  Setting up `annotate` benchmark (can take up to a few minutes)
  Creating the base data-env
  creating new file: "$TESTTMP/running-test-den/data-env-2/data-env.poulpe"
  Registering graph details
  Registering the format details
  Setting up working-copy benchmarks
  Warning: running setup-working-copy without a data brick
  (non-default working-copy variants will be unavailable)
  Setting up `delta-find` benchmark (can take a very long time)
  Setting up `annotate` benchmark (can take up to a few minutes)

Test execution of tasks
=======================

  $ cat << EOF > tasks
  > RUN hg:MERCURIAL_VERSION=6.8:MERCURIAL_FLAVOR=pure      bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  > RUN hg:MERCURIAL_VERSION=6.8:MERCURIAL_FLAVOR=pure      bar hg/cat.pbd:files=all-root:output=json:rev=tip
  > RUN hg:MERCURIAL_VERSION=6.8.1:MERCURIAL_FLAVOR=pure    bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  > RUN hg:MERCURIAL_VERSION=6.8.1:MERCURIAL_FLAVOR=pure    bar hg/cat.pbd:files=all-root:output=json:rev=tip
  > RUN hg:MERCURIAL_VERSION=6.8.2:MERCURIAL_FLAVOR=pure    bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  > RUN hg:MERCURIAL_VERSION=6.8.2:MERCURIAL_FLAVOR=pure    bar hg/cat.pbd:files=all-root:output=json:rev=tip
  > EOF
  $ poulpe den-execute-tasks --schedule-path tasks --report-path report | grep -v "adding remote bookmark"
  POULPE: using Python python3
  POULPE: Python version Python 3.11.6
  POULPE: Python executable path $TESTTMP/running-test-den/.venv/bin/python3
  POULPE: Python executable real path $TESTTMP/running-test-den/.venv/bin/python3
  POULPE: cloning mercurial from * (glob)
  (sharing from existing pooled repository *) (glob)
  searching for changes
  no changes found
  POULPE: clone done
  POULPE: updating to 6.8
  2310 files updated, 0 files merged, 0 files removed, 0 files unresolved
  POULPE: building the virtual environment
  POULPE: flavor okay (pure)
  POULPE: installing Mercurial
  POULPE: install okay
  POULPE: no re2 module to install
  POULPE: cleaning up
  POULPE: creating the bin-env.shell file
  [1/6] running hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8 bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  [2/6] running hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8 bar hg/cat.pbd:files=all-root:output=json:rev=tip
  POULPE: using Python python3
  POULPE: Python version Python 3.* (glob)
  POULPE: Python executable path $TESTTMP/running-test-den/.venv/bin/python3
  POULPE: Python executable real path $TESTTMP/running-test-den/.venv/bin/python3
  POULPE: cloning mercurial from * (glob)
  (sharing from existing pooled repository *) (glob)
  searching for changes
  no changes found
  POULPE: clone done
  POULPE: updating to 6.8.1
  2310 files updated, 0 files merged, 0 files removed, 0 files unresolved
  POULPE: building the virtual environment
  POULPE: flavor okay (pure)
  POULPE: installing Mercurial
  POULPE: install okay
  POULPE: no re2 module to install
  POULPE: cleaning up
  POULPE: creating the bin-env.shell file
  [3/6] running hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.1 bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  [4/6] running hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.1 bar hg/cat.pbd:files=all-root:output=json:rev=tip
  POULPE: using Python python3
  POULPE: Python version Python 3.* (glob)
  POULPE: Python executable path $TESTTMP/running-test-den/.venv/bin/python3
  POULPE: Python executable real path $TESTTMP/running-test-den/.venv/bin/python3
  POULPE: cloning mercurial from * (glob)
  (sharing from existing pooled repository *) (glob)
  searching for changes
  no changes found
  POULPE: clone done
  POULPE: updating to 6.8.2
  2310 files updated, 0 files merged, 0 files removed, 0 files unresolved
  POULPE: building the virtual environment
  POULPE: flavor okay (pure)
  POULPE: installing Mercurial
  POULPE: install okay
  POULPE: no re2 module to install
  POULPE: cleaning up
  POULPE: creating the bin-env.shell file
  [5/6] running hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.2 bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  [6/6] running hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.2 bar hg/cat.pbd:files=all-root:output=json:rev=tip
  6 out of 6 tasks have succeeded


Check the created bin-envs

  $ ls -1 bin-envs
  03ef137b981bcd9660ad9555e514c17f3711081c3a423a3edf4a7ad5ee10b7ef
  542e1c025b1aa5010386b448cff802f6a2dc8402719ee53c5806e7c49ca5cb49
  e4fe6651f0ad3b057d29cea41ff5927ed459d9b0248acb2f1b8340a3595881f0

Check the created result
  $ ls -1 results
  21f35bf6395cb208d00ecc4e82b8cff9559a2078a454e643abf5ab45037b8f95.pbr
  4310cf49e603b2b3f254e9e34110bb533f7467b6944b92e952b5077b7194b383.pbr
  80583cba1f06ac41ae5df7d8d834b54f0258358b29232c1f1e14d354fa90de9a.pbr
  b5e07c308c15a7521f4e509610173681b8650fb5f84e8e3279ce0fa6247f8141.pbr
  cee0708fc158e5fe5ad520ed3b17998495a7c6832bec4213e32f80021ad84b05.pbr
  e5e32b349dc6dae476a99facf2e29226384f2ce98fd94f90bb1d5637fe863fd3.pbr

Check the run report

  $ cat report
  ?????????????????????????? ### starting: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8 bar hg/cat.pbd:files=all-root:output=plain:rev=tip (glob)
  ??????????????????????????     duration: * seconds (glob)
  ??????????????????????????     return:   0 (glob)
  ??????????????????????????     result:   results/80583cba1f06ac41ae5df7d8d834b54f0258358b29232c1f1e14d354fa90de9a.pbr (glob)
  ?????????????????????????? ### starting: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8 bar hg/cat.pbd:files=all-root:output=json:rev=tip (glob)
  ??????????????????????????     duration: * seconds (glob)
  ??????????????????????????     return:   0 (glob)
  ??????????????????????????     result:   results/4310cf49e603b2b3f254e9e34110bb533f7467b6944b92e952b5077b7194b383.pbr (glob)
  ?????????????????????????? ### starting: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.1 bar hg/cat.pbd:files=all-root:output=plain:rev=tip (glob)
  ??????????????????????????     duration: * seconds (glob)
  ??????????????????????????     return:   0 (glob)
  ??????????????????????????     result:   results/e5e32b349dc6dae476a99facf2e29226384f2ce98fd94f90bb1d5637fe863fd3.pbr (glob)
  ?????????????????????????? ### starting: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.1 bar hg/cat.pbd:files=all-root:output=json:rev=tip (glob)
  ??????????????????????????     duration: * seconds (glob)
  ??????????????????????????     return:   0 (glob)
  ??????????????????????????     result:   results/cee0708fc158e5fe5ad520ed3b17998495a7c6832bec4213e32f80021ad84b05.pbr (glob)
  ?????????????????????????? ### starting: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.2 bar hg/cat.pbd:files=all-root:output=plain:rev=tip (glob)
  ??????????????????????????     duration: * seconds (glob)
  ??????????????????????????     return:   0 (glob)
  ??????????????????????????     result:   results/21f35bf6395cb208d00ecc4e82b8cff9559a2078a454e643abf5ab45037b8f95.pbr (glob)
  ?????????????????????????? ### starting: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.2 bar hg/cat.pbd:files=all-root:output=json:rev=tip (glob)
  ??????????????????????????     duration: * seconds (glob)
  ??????????????????????????     return:   0 (glob)
  ??????????????????????????     result:   results/b5e07c308c15a7521f4e509610173681b8650fb5f84e8e3279ce0fa6247f8141.pbr (glob)

Test basic result comparison
============================

note: this is mostly another test piggy backing on the fact we have sesult around to test comparison


Finding results
---------------

  $ poulpe result-search results
  results/b5e07c308c15a7521f4e509610173681b8650fb5f84e8e3279ce0fa6247f8141.pbr
  results/21f35bf6395cb208d00ecc4e82b8cff9559a2078a454e643abf5ab45037b8f95.pbr
  results/cee0708fc158e5fe5ad520ed3b17998495a7c6832bec4213e32f80021ad84b05.pbr
  results/e5e32b349dc6dae476a99facf2e29226384f2ce98fd94f90bb1d5637fe863fd3.pbr
  results/4310cf49e603b2b3f254e9e34110bb533f7467b6944b92e952b5077b7194b383.pbr
  results/80583cba1f06ac41ae5df7d8d834b54f0258358b29232c1f1e14d354fa90de9a.pbr


plain comparison
----------------

  $ poulpe result-search results | poulpe result-compare
  ### data-env-vars.name            = ba-bar
    # benchmark.name                = hg.command.cat
    # bin-env-vars.hg.flavor        = pure
    # bin-env-vars.hg.py-re2-module = default
    # benchmark.variants.files      = all-root
    # benchmark.variants.output     = json
    # benchmark.variants.rev        = tip
  11f41248595b: * (glob)
  11a9e2fc0caf: * (glob)
  eae3ec345e5e: * (glob)
  ### data-env-vars.name            = ba-bar
    # benchmark.name                = hg.command.cat
    # bin-env-vars.hg.flavor        = pure
    # bin-env-vars.hg.py-re2-module = default
    # benchmark.variants.files      = all-root
    # benchmark.variants.output     = plain
    # benchmark.variants.rev        = tip
  11f41248595b: * (glob)
  11a9e2fc0caf: * (glob)
  eae3ec345e5e: * (glob)

  $ poulpe result-search results | poulpe result-compare --path-file -
  ### data-env-vars.name            = ba-bar
    # benchmark.name                = hg.command.cat
    # bin-env-vars.hg.flavor        = pure
    # bin-env-vars.hg.py-re2-module = default
    # benchmark.variants.files      = all-root
    # benchmark.variants.output     = json
    # benchmark.variants.rev        = tip
  11f41248595b: * (glob)
  11a9e2fc0caf: * (glob)
  eae3ec345e5e: * (glob)
  ### data-env-vars.name            = ba-bar
    # benchmark.name                = hg.command.cat
    # bin-env-vars.hg.flavor        = pure
    # bin-env-vars.hg.py-re2-module = default
    # benchmark.variants.files      = all-root
    # benchmark.variants.output     = plain
    # benchmark.variants.rev        = tip
  11f41248595b: * (glob)
  11a9e2fc0caf: * (glob)
  eae3ec345e5e: * (glob)

  $ poulpe result-search results --content-as-json | poulpe result-compare --json-file -
  ### data-env-vars.name            = ba-bar
    # benchmark.name                = hg.command.cat
    # bin-env-vars.hg.flavor        = pure
    # bin-env-vars.hg.py-re2-module = default
    # benchmark.variants.files      = all-root
    # benchmark.variants.output     = json
    # benchmark.variants.rev        = tip
  11f41248595b: * (glob)
  11a9e2fc0caf: * (glob)
  eae3ec345e5e: * (glob)
  ### data-env-vars.name            = ba-bar
    # benchmark.name                = hg.command.cat
    # bin-env-vars.hg.flavor        = pure
    # bin-env-vars.hg.py-re2-module = default
    # benchmark.variants.files      = all-root
    # benchmark.variants.output     = plain
    # benchmark.variants.rev        = tip
  11f41248595b: * (glob)
  11a9e2fc0caf: * (glob)
  eae3ec345e5e: * (glob)

On a specific dimension
-----------------------

  $ poulpe result-search results | poulpe result-compare --dimension=benchmark.variants.output
  ### data-env-vars.name             = ba-bar
    # benchmark.name                 = hg.command.cat
    # bin-env-vars.hg.flavor         = pure
    # bin-env-vars.hg.py-re2-module  = default
    # bin-env-vars.hg.changeset.node = 11a9e2fc0caf0800625612e374139e4d825349a6
    # benchmark.variants.files       = all-root
    # benchmark.variants.rev         = tip
  json: \d+\.\d*  ~~~~~ (re)
  plain: \d+\.\d* .* (re)
  ### data-env-vars.name             = ba-bar
    # benchmark.name                 = hg.command.cat
    # bin-env-vars.hg.flavor         = pure
    # bin-env-vars.hg.py-re2-module  = default
    # bin-env-vars.hg.changeset.node = 11f41248595b6dd7e0fbb434ecbf75c418785a4c
    # benchmark.variants.files       = all-root
    # benchmark.variants.rev         = tip
  json: \d+\.\d*  ~~~~~ (re)
  plain: \d+\.\d* .* (re)
  ### data-env-vars.name             = ba-bar
    # benchmark.name                 = hg.command.cat
    # bin-env-vars.hg.flavor         = pure
    # bin-env-vars.hg.py-re2-module  = default
    # bin-env-vars.hg.changeset.node = eae3ec345e5e62e653de32a87a70f6fa7241afde
    # benchmark.variants.files       = all-root
    # benchmark.variants.rev         = tip
  json: \d+\.\d*  ~~~~~ (re)
  plain: \d+\.\d* .* (re)

Some dimension being ignored

  $ poulpe result-search results | poulpe result-compare \
  > --dimension=benchmark.variants.output \
  > --ignore-dimension bin-env-vars.hg.py-re2-module \
  > --ignore-dimension bin-env-vars.hg.changeset.node
  ### data-env-vars.name       = ba-bar
    # benchmark.name           = hg.command.cat
    # bin-env-vars.hg.flavor   = pure
    # benchmark.variants.files = all-root
    # benchmark.variants.rev   = tip
  json: * (glob)
  json: * (glob)
  json: * (glob)
  plain: * (glob)
  plain: * (glob)
  plain: * (glob)

Select comparison base
----------------------


  $ poulpe result-search results | poulpe result-compare \
  > --dimension=benchmark.variants.output \
  > --reference-key plain
  ### data-env-vars.name             = ba-bar
    # benchmark.name                 = hg.command.cat
    # bin-env-vars.hg.flavor         = pure
    # bin-env-vars.hg.py-re2-module  = default
    # bin-env-vars.hg.changeset.node = 11a9e2fc0caf0800625612e374139e4d825349a6
    # benchmark.variants.files       = all-root
    # benchmark.variants.rev         = tip
  json: \d+\.\d* .* (re)
  plain: \d+\.\d*  ~~~~~ (re)
  ### data-env-vars.name             = ba-bar
    # benchmark.name                 = hg.command.cat
    # bin-env-vars.hg.flavor         = pure
    # bin-env-vars.hg.py-re2-module  = default
    # bin-env-vars.hg.changeset.node = 11f41248595b6dd7e0fbb434ecbf75c418785a4c
    # benchmark.variants.files       = all-root
    # benchmark.variants.rev         = tip
  json: \d+\.\d* .* (re)
  plain: \d+\.\d*  ~~~~~ (re)
  ### data-env-vars.name             = ba-bar
    # benchmark.name                 = hg.command.cat
    # bin-env-vars.hg.flavor         = pure
    # bin-env-vars.hg.py-re2-module  = default
    # bin-env-vars.hg.changeset.node = eae3ec345e5e62e653de32a87a70f6fa7241afde
    # benchmark.variants.files       = all-root
    # benchmark.variants.rev         = tip
  json: \d+\.\d* .* (re)
  plain: \d+\.\d*  ~~~~~ (re)


Test lazy mode
==============

  $ poulpe den-execute-tasks --lazy --schedule-path tasks --report-path report-lazy
  [1/6] skipping hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8 bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  (a result already exists for this task)
  [2/6] skipping hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8 bar hg/cat.pbd:files=all-root:output=json:rev=tip
  (a result already exists for this task)
  [3/6] skipping hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.1 bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  (a result already exists for this task)
  [4/6] skipping hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.1 bar hg/cat.pbd:files=all-root:output=json:rev=tip
  (a result already exists for this task)
  [5/6] skipping hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.2 bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  (a result already exists for this task)
  [6/6] skipping hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.2 bar hg/cat.pbd:files=all-root:output=json:rev=tip
  (a result already exists for this task)
  6 out of 6 tasks have succeeded

the report mention the skipping

  $ cat report-lazy
  * ### skipping: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8 bar hg/cat.pbd:files=all-root:output=plain:rev=tip (glob)
  ??????????????????????????     result:   results/80583cba1f06ac41ae5df7d8d834b54f0258358b29232c1f1e14d354fa90de9a.pbr (glob)
  * ### skipping: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8 bar hg/cat.pbd:files=all-root:output=json:rev=tip (glob)
  ??????????????????????????     result:   results/4310cf49e603b2b3f254e9e34110bb533f7467b6944b92e952b5077b7194b383.pbr (glob)
  * ### skipping: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.1 bar hg/cat.pbd:files=all-root:output=plain:rev=tip (glob)
  ??????????????????????????     result:   results/e5e32b349dc6dae476a99facf2e29226384f2ce98fd94f90bb1d5637fe863fd3.pbr (glob)
  * ### skipping: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.1 bar hg/cat.pbd:files=all-root:output=json:rev=tip (glob)
  ??????????????????????????     result:   results/cee0708fc158e5fe5ad520ed3b17998495a7c6832bec4213e32f80021ad84b05.pbr (glob)
  * ### skipping: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.2 bar hg/cat.pbd:files=all-root:output=plain:rev=tip (glob)
  ??????????????????????????     result:   results/21f35bf6395cb208d00ecc4e82b8cff9559a2078a454e643abf5ab45037b8f95.pbr (glob)
  * ### skipping: hg:MERCURIAL_FLAVOR=pure:MERCURIAL_VERSION=6.8.2 bar hg/cat.pbd:files=all-root:output=json:rev=tip (glob)
  ??????????????????????????     result:   results/b5e07c308c15a7521f4e509610173681b8650fb5f84e8e3279ce0fa6247f8141.pbr (glob)

the results are still there

  $ poulpe result-search results | poulpe result-compare
  ### data-env-vars.name            = ba-bar
    # benchmark.name                = hg.command.cat
    # bin-env-vars.hg.flavor        = pure
    # bin-env-vars.hg.py-re2-module = default
    # benchmark.variants.files      = all-root
    # benchmark.variants.output     = json
    # benchmark.variants.rev        = tip
  11f41248595b: * (glob)
  11a9e2fc0caf: * (glob)
  eae3ec345e5e: * (glob)
  ### data-env-vars.name            = ba-bar
    # benchmark.name                = hg.command.cat
    # bin-env-vars.hg.flavor        = pure
    # bin-env-vars.hg.py-re2-module = default
    # benchmark.variants.files      = all-root
    # benchmark.variants.output     = plain
    # benchmark.variants.rev        = tip
  11f41248595b: * (glob)
  11a9e2fc0caf: * (glob)
  eae3ec345e5e: * (glob)
