=====================================
Test the generation of benchmark Task
=====================================

  $ . $TESTDIR/testlib/base-test-setup.sh
  $ SRC_DIR=$TESTDIR/..

Setup a Den
-----------

  $ $PYTHON $SRC_DIR/bin/setup-poulpe-den listing-test-den
  Creating folders
  Create symlinks to Poulpe
  Installing poulpe (editable) into a new venv
  Creating a "bin/" directory with a few utilities
  Cloning repositories to benchmark
  Updating environment variables
  Poulpe Den ready to use in "$TESTTMP/listing-test-den"
  Run . "$TESTTMP/listing-test-den/bin/activate" to activate the environment
  $ cd listing-test-den
  $ . bin/activate

reduce the amount of test we have to deal with to stabilize this test

  $ ls -l benchmarks
  total * (glob)
  * hg -> ../tooling/poulpe/suites/hg/benchmarks (glob)
  * swh -> ../tooling/poulpe/suites/swh/benchmarks (glob)
  $ rm benchmarks/hg
  $ mkdir benchmarks/hg
  $ cp tooling/poulpe/suites/hg/benchmarks/perf-read-revisions.pbd benchmarks/hg
  $ cp tooling/poulpe/suites/hg/benchmarks/cat.pbd benchmarks/hg
  $ cp tooling/poulpe/suites/hg/benchmarks/debug-update-cache.pbd benchmarks/hg

Setup some data-env
-------------------

XXX consider muting this

  $ "$TESTDIR/testlib/setup-test-data-env.sh" data-envs
  Creating the base data-env
  creating new file: "$TESTTMP/listing-test-den/data-env-1/data-env.poulpe"
  Registering graph details
  Registering the format details
  Setting up working-copy benchmarks
  Warning: running setup-working-copy without a data brick
  (non-default working-copy variants will be unavailable)
  Setting up `delta-find` benchmark (can take a very long time)
  Setting up `annotate` benchmark (can take up to a few minutes)
  Creating the base data-env
  creating new file: "$TESTTMP/listing-test-den/data-env-2/data-env.poulpe"
  Registering graph details
  Registering the format details
  Setting up working-copy benchmarks
  Warning: running setup-working-copy without a data brick
  (non-default working-copy variants will be unavailable)
  Setting up `delta-find` benchmark (can take a very long time)
  Setting up `annotate` benchmark (can take up to a few minutes)

Test generation of Tasks
========================

no-filter-run
-------------

  $ poulpe den-generate-tasks hg:MERCURIAL_VERSION=6.9 > tasks
  $ wc -l < tasks
  6
  $ sort --unique < tasks | wc -l
  6
(we grep to skip later introduced benchmark)
  $ head tasks
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/debug-update-cache.pbd
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/perf-read-revisions.pbd
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/debug-update-cache.pbd
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/perf-read-revisions.pbd

no-filter-run using all variants
--------------------------------

  $ poulpe den-generate-tasks --all-variants hg:MERCURIAL_VERSION=6.9 > tasks
  $ wc -l < tasks
  110
  $ sort --unique < tasks | wc -l
  110
  $ head tasks
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=json:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=json:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=json:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-glob:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-glob:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-glob:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-glob:output=json:rev=working-copy

filtering according to the data-env
-----------------------------------

  $ poulpe den-generate-tasks --all-variants hg:MERCURIAL_VERSION=6.9 \
  >   --data-env-filter mercurial.repo.graph.visible-revision-count="re:^1....$" \
  >   > tasks
  $ wc -l < tasks
  55
  $ sort --unique < tasks | wc -l
  55
  $ head tasks
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-root:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-root:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-root:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-root:output=json:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-root:output=json:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-root:output=json:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-glob:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-glob:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-glob:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-glob:output=json:rev=working-copy

  $ poulpe den-generate-tasks --all-variants hg:MERCURIAL_VERSION=6.9 \
  >   --data-env-filter name="ba-bar" \
  >   > tasks
  $ wc -l < tasks
  55
  $ sort --unique < tasks | wc -l
  55
  $ head tasks
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=json:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=json:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=json:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-glob:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-glob:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-glob:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-glob:output=json:rev=working-copy

filtering according benchmark variants
--------------------------------------

Filtering on a variants that is not the first one variant

  $ poulpe den-generate-tasks --all-variants hg:MERCURIAL_VERSION=6.9 \
  >   --benchmark-variant-filter output="plain" \
  >   --benchmark-name-filter "re:^.*\.command\.cat$" \
  >   > tasks
  $ wc -l < tasks
  48
  $ sort --unique < tasks | wc -l
  48
  $ head tasks
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-root:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-glob:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-glob:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-glob:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-sorted:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-sorted:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-sorted:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=plain:rev=working-copy

filter for variants that does not exists on the benchmark are ignored

  $ poulpe den-generate-tasks --all-variants hg:MERCURIAL_VERSION=6.9 \
  >   --benchmark-variant-filter files="re:^.*shuffled$" \
  >   > tasks
  $ wc -l < tasks
  50
  $ sort --unique < tasks | wc -l
  50
  $ head tasks
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=json:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=json:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=json:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-filepath-shuffled:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-filepath-shuffled:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-filepath-shuffled:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-filepath-shuffled:output=json:rev=working-copy

filtering according benchmark name (and variants)
-------------------------------------------------

  $ poulpe den-generate-tasks --all-variants hg:MERCURIAL_VERSION=6.9 \
  >   --benchmark-name-filter "hg.command.cat" \
  >   --benchmark-variant-filter files="re:^.*shuffled$" \
  >   > tasks
  $ wc -l < tasks
  36
  $ sort --unique < tasks | wc -l
  36
  $ head tasks
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=json:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=json:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled:output=json:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-filepath-shuffled:output=plain:rev=working-copy
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-filepath-shuffled:output=plain:rev=tip
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-filepath-shuffled:output=plain:rev=default
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-filepath-shuffled:output=json:rev=working-copy

filtering without all variant will only combine variant with a filter
---------------------------------------------------------------------

The dimension that does not have a filter will use the default value.


  $ poulpe den-generate-tasks hg:MERCURIAL_VERSION=6.9 \
  >   --benchmark-name-filter "hg.command.cat" \
  >   --benchmark-variant-filter files="re:^.*shuffled$" \
  >   > tasks
  $ wc -l < tasks
  6
  $ sort --unique < tasks | wc -l
  6
  $ head tasks
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-path-shuffled
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-filepath-shuffled
  RUN hg:MERCURIAL_VERSION=6.9 bar hg/cat.pbd:files=all-list-pattern-shuffled
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-list-path-shuffled
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-list-filepath-shuffled
  RUN hg:MERCURIAL_VERSION=6.9 foo hg/cat.pbd:files=all-list-pattern-shuffled

Test that the generated tasks are usable
========================================

We have to grep the bundle test out because the generate "invalid" tasks as we
does not apply constraint at generation time.

  $ poulpe den-generate-tasks --all-variants \
  > hg:MERCURIAL_VERSION=6.8.2 hg:MERCURIAL_VERSION=6.8.1 \
  > --benchmark-variant-filter "rev=tip" \
  > | sort | head -n 3 > tasks

(Filter output until "clone done" since it varies a lot and is not that useful)

  $ poulpe den-execute-tasks --schedule-path tasks | sed '/clone done/,$!d'
  POULPE: clone done
  POULPE: updating to 6.8.1
  2310 files updated, 0 files merged, 0 files removed, 0 files unresolved
  POULPE: building the virtual environment
  POULPE: flavor okay (default)
  POULPE: installing Mercurial
  POULPE: install okay
  POULPE: no re2 module to install
  POULPE: cleaning up
  POULPE: creating the bin-env.shell file
  [1/3] running hg:MERCURIAL_VERSION=6.8.1 bar hg/cat.pbd:files=all-glob:output=json:rev=tip
  [2/3] running hg:MERCURIAL_VERSION=6.8.1 bar hg/cat.pbd:files=all-glob:output=plain:rev=tip
  [3/3] running hg:MERCURIAL_VERSION=6.8.1 bar hg/cat.pbd:files=all-list-filepath-shuffled:output=json:rev=tip
  3 out of 3 tasks have succeeded

Check the created bin-envs

  $ ls -1 bin-envs
  9f52449926985c4d3158e5cd7c3742a5af6cf1030f3625087fcb111a1607d887

Check the created result
  $ ls -1 results
  2a1885a653eabb0c0ae5bddca70486cce91f4cbffe6de3d4cbabcaa640a75778.pbr
  55869753db8ff6412f30a396f6de8cf07ff506d656af95de27022c501eb2a405.pbr
  7675e4465f9c343008447c748cb718bb9c7e8b0d0b18c03c388dfaa4c5895c9b.pbr


