#!/bin/bash
set -euo pipefail

TARGET="$1"

SETUP_PATH="$TESTDIR/../suites/hg/data-env-setup/"
TMP_DATA_DIR="$TESTTMP/tmp-data-envs"
mkdir -p $TMP_DATA_DIR
hg init ./data-env-1/base-repo/ --config format.revlog-compression=zlib
cat << EOF >> ./data-env-1/base-repo/.hg/hgrc
[storage]
dirstate-v2.slow-path=allow
revlog.persistent-nodemap.slow-path=allow
EOF
hg -R ./data-env-1/base-repo/ debugbuilddag --new-file \
'.:z'\
'+1309:a'\
'<z+1177:b/a'\
'+1033:c'\
'<b+1330:d/c'\
'+1395:e'\
'<a+1081:f'\
'<b+1070:g/e'\
'+1081:h/f'\
'+1083:i'\
'<c+1226:j/f'

"${SETUP_PATH}"/setup-full.py  --name "foo-test" ./data-env-1/ --repo base-repo

mkdir ./data-env-2
hg init ./data-env-2/the-repo/ --config format.revlog-compression=zlib
cat << EOF >> ./data-env-2/the-repo/.hg/hgrc
[storage]
dirstate-v2.slow-path=allow
revlog.persistent-nodemap.slow-path=allow
EOF
hg -R ./data-env-2/the-repo/ debugbuilddag --new-file \
'.:z'\
'+1100:a'\
'<z+177:b/a'\
'+133:c'\
'<b+130:d/c'\
'+1350:e'\
'<a+181:f'\
'<b+170:g/e'\
'+181:h/f'\
'+83:i'\
'<c+126:j/f'

"${SETUP_PATH}"/setup-full.py --name "ba-bar" ./data-env-2 --repo the-repo

mv ./data-env-1 "$TARGET"/foo
mv ./data-env-2 "$TARGET"/bar
